import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.geom.*;

public abstract class BonusObject extends MazeObject {
    //Random rg;
    int lastMove;
    int counter;
    Maze theMaze;

    public BonusObject(Maze theMaze) {
	this(0,0, theMaze);
    }

    public BonusObject(int x, int y, Maze aMaze) {
	super(x,y);
	theMaze = aMaze;
	//rg = new Random();
	lastMove = GamePlayer.nextInt(4);
	counter = 0;
    }

    public int nextMove() {
	// move every third turn
	if (counter == 2) {
	    counter = 0;
	    // pick new direction about every 10th move
	    // or if we're hitting a maze border
	    if (hittingWall() || GamePlayer.nextFloat() < 0.1) {
		lastMove = GamePlayer.nextInt(4);
	    }
	    return lastMove;
	}
	else {
	    counter++;
	    return -1;
	}
    }

    //public abstract void draw(Graphics2D g2, int x, int y, int squareSize);

    private boolean hittingWall() {
	Position futurePos = GameSimulator.getNewPos(x(), y(), lastMove);
	if (theMaze.CoordsAreInMaze(futurePos.x, futurePos.y))
	    return false;
	else
	    return true;
    }
}
