import java.util.*;

public class LocalMap {
    static final int NORTH = 0;
    static final int EAST  = 1;
    static final int SOUTH = 2;
    static final int WEST  = 3;
    static final int STOP  = 4;
    Maze theMaze;
    Position center;
    MapEntry[][] theMap;

    public LocalMap(Maze maze, Position center) {
	//System.out.println("Maze is " + maze);
	//System.out.println("Center is " + center);
	theMaze = maze;
	theMap = new MapEntry[theMaze.width][theMaze.height];
	//System.out.println("theMap is " + theMap);
	//System.out.println("Height is " + theMaze.height + " width is " + theMaze.width);
	for (int i=0;i<theMaze.width;i++) {
	    for (int j=0;j<theMaze.height;j++) 		{
		theMap[i][j] = new MapEntry();
		theMap[i][j].x = i;
		theMap[i][j].y = j;
	    }
	}
	this.center = center;
    }

    public void clearMap() {
	for (int i=0;i<theMaze.width;i++)
	    for (int j=0;j<theMaze.height;j++) {
		theMap[i][j].done = false;
		theMap[i][j].dist  = Math.abs(center.x - i) + Math.abs(center.y - j);		    
	    }
    }

    public void setCenter(Position p) {
	if (center == null || (p.x != center.x || 
	    p.y != center.y)) {
	    //	    System.out.println("p.x is " + p.x + " p.y is " + p.y);
	    center = p;
	    if (p != null) {
		clearMap();
	    }
	    theMap[p.x][p.y].set(0, STOP);
	}
    }
    
    public void plan() {
	LinkedList q = new LinkedList();
	q.addLast(theMap[center.x][center.y]);
	Position p = new Position(0,0);
	while (q.size() > 0) {
	    MapEntry top = (MapEntry) q.removeFirst();
	    for (int i=0;i<4;i++) {
		if (theMaze.squareInDir(top.x, top.y, i, p)) { // if I can get there
		    if (!theMap[p.x][p.y].done) { // if I've not yet been here
			theMap[p.x][p.y].set(top.dist+1, (i+2)%4);
			q.addLast(theMap[p.x][p.y]);
		    }
		}
	    }
	}
    }

    public int getAction(Position loc) {
	return(theMap[loc.x][loc.y].action);
    }

    public int getDist(Position loc) {
	return(theMap[loc.x][loc.y].dist);	
    }

}

